
# ----------------------------------------------------------
# advas
# advanced search algorithms implemented as a python module
#
# (C) 2002 Frank Hofmann, Chemnitz, Germany
# email fh@efho.de
#
# example for using is_language funcion to identify the 
# language of a given document 
#
# ----------------------------------------------------------

# changed 2002-10-01

# import advas module
import advas
import string

# define lines of text
line_en = "The sense of the single letter options may be inverted by using + instead of -. Some of the single letter option names refer to an option being off, in which case the inversion of that name refers to the option being on. For example, +n is the short name of exec, and -n is the short name of its inversion, noexec."

line_de = "Ein betrachtetes Dokument wird linear verarbeitet. In einer Liste wird gespeichert, wie haeufig jedes einzelne Wort im Dokument vorkommt. Man nimmt an, dass, je haeufiger ein Wort im Text enthalten ist, dieses Wort umso relevanter im Sinne von bedeutungstragend fuer den Inhalt des Textes ist. Diese Termgewichte werden in einem Vektor zusammengefasst. Jede Position im Vektor repraesentiert einen Term. Der Wert an dieser Position enthaelt das spezifische Termgewicht eines Wortes fr diesen Text oder dieses Dokument"

print "\nGerman text"

value = advas.is_language(line_de, "stoplist_DE.txt", 1)
print "assume german text:  ", value

value = advas.is_language(line_en, "stoplist_DE.txt", 1)
print "assume english text: ", value

print "\nEnglish text"

value = advas.is_language(line_de, "stoplist_EN.txt", 1)
print "assume german text:  ", value

value = advas.is_language(line_en, "stoplist_EN.txt", 1)
print "assume english text: ", value
